# rENA <img src="man/figures/logo.png" align="right" alt="" width="120" />

[![build status](https://gitlab.com/epistemic-analytics/qe-packages/rENA/badges/master/build.svg)](https://gitlab.com/epistemic-analytics/qe-packages/rENA/commits/master)
[![coverage report](https://gitlab.com/epistemic-analytics/qe-packages/rENA/badges/master/coverage.svg)](https://gitlab.com/epistemic-analytics/qe-packages/rENA/commits/master)

## What is ENA
[Epistemic Network Analysis](http://www.epistemicnetwork.org) (ENA) is a method for identifying and quantifying connections among elements in coded data and representing them in dynamic network models. A key feature of the ENA tool is that it enables researchers compare different networks, both visually and through summary statistics that reflect the weighted structure of connections. The interface also allows users to see the original data that contributed to each of the connections in the network representation. ENA can thus be used to address a wide range of qualitative and quantitative research questions.

Researchers have used ENA to analyze and visualize a wide range of phenomena, including: cognitive connections that students make while solving complex problems; interactions among different regions of the brain in fMRI data; social gaze coordination; integration of operative skills during surgical procedures; and many others.

---

## Installation

### Install release version from CRAN
[![build status](https://gitlab.com/epistemic-analytics/qe-packages/rENA/badges/master/build.svg)](https://gitlab.com/epistemic-analytics/qe-packages/rENA/commits/master)
[![coverage report](https://gitlab.com/epistemic-analytics/qe-packages/rENA/badges/master/coverage.svg)](https://gitlab.com/epistemic-analytics/qe-packages/rENA/commits/master)

```
install.packages("rENA")
```

### Install development version
[![build status](https://gitlab.com/epistemic-analytics/qe-packages/rENA/badges/develop/build.svg)](https://gitlab.com/epistemic-analytics/qe-packages/rENA/commits/develop)
[![coverage report](https://gitlab.com/epistemic-analytics/qe-packages/rENA/badges/develop/coverage.svg)](https://gitlab.com/epistemic-analytics/qe-packages/rENA/commits/develop)


```
devtools::install_git(url = "https://gitlab.com/epistemic-analytics/qe-packages/rENA", ref="develop")
```


---
## Resources

To learn more about ENA, visit the [resources page](http://www.epistemicnetwork.org/resources/).
